//
//	RX64N????????????(??????????)
//	??2 LCD??? N2
//
//	09/01/03 #221 CAN???????? (???#2) ???
//		???????????????
//	11/02/19 RX64???????
//

#include "D:\\_F\\___CQWORK\\_Book7\\WizC15\\RX64N-Test\\221-N2\\221_Auto.h"

//#include "..\\..\\Common\\2515Tag.h"
//#include "..\\..\\Common\\2515Reg.h"
//#include "..\\..\\Common\\CAN2515.h"
#include "CAN2515Def.h"
//#include "..\\CANMsg.h"
#include "..\\..\\Common\\WSN221.h"		// #221???I/O??

#include <string.h>


// -----------------------------
// ??2 ?????ID
// -----------------------------

// RX???(N1)?CAN-LCD(N2)?????????????
#define N2_LCD_NUM 0x0203		// ????????2?????????

// CAN-LCD(N2)????RX???(N1)??????????
#define N1_LED_ON	0x0101		// ???1?LED ON
#define N1_LED_OFF	0x0102		// ???1?LED OFF


// config 0x2FF2 0x3FFF

void UserInterrupt()
{
	// Insert your code here

 #asmline SETPCLATH UserIntReturn,-1  ; SETPCLATH for interrupt routine
 #asmline goto UserIntReturn	      ; Assembler - go back to interrupt routine
}


#define true  1
#define false 0

char StrBuf[16];
BYTE MsgBuf[14];


void UserInitialise()
{
	WORD msg;
	BYTE reg, reg2, reg3, reg4;
	struct tag_TXBnCTRL ctrl;
	struct tag_TXBnDLC dlc;

	// ???????disable
	ADCON0 = 0;
	ADCON1 = 0;		// All digtal
	ANSEL = 0;
	ANSELH = 0;		// All digtal
	CM1CON0 = 0;
	CM2CON0 = 0;

	// LED?????????
	LED1_TRIS &= ~(1<<LED1_BIT);
	LED2_TRIS &= ~(1<<LED2_BIT);
	LED3_TRIS &= ~(1<<LED3_BIT);
	LEDBK_TRIS &= ~(1<<LEDBK_BIT);

	LED1_ON;
	LED2_ON;
	LED3_ON;
	Wait(200);
	LEDBK_ON;
	LED1_OFF;
	LED2_OFF;
	LED3_OFF;

	// CAN?? ??? ???????? ???
	CANInit(CAN_BRP_20MHz_125KBPS);			// CLOCK 20MHz CAN 125bps
	// ?????????? SID 11bit
	CANSetSidFilter0(0x0000);
	CANSetSidFilter1(0x0000);
	CANSetSidFilter2(0x0000);
	CANSetSidFilter3(0x0000);
	CANSetSidFilter4(0x0000);
	CANSetSidFilter5(0x0000);
	CANSetSidMask0(0x0000);
	CANSetSidMask1(0x0000);

	CANSetFilterRxB0(3);			// RXB0???????????????
	CANSetFilterRxB1(3);			// RXB1???????????????

	CANSetOpMode(CAM_MODE_NORMAL);	// ????????
}


void UserLoop()
{
	WORD msg;
//	BYTE reg;
	WORD count;

	if(CANRxCheck(0)) {			// ??????
		// ????

//		MsgBuf[0] = CANReadReg(RXB0CTRL);
//		reg = CANReadReg(CANINTF);

//		sprintf(StrBuf, "%02X %02X ", MsgBuf[0], reg);
//		LCDPrintAt(0, 0);
//		LCDString(StrBuf);

		CANRxB0Read(&MsgBuf[1], 0);			// ?????????
		msg = ((WORD)MsgBuf[1] << 3);		// SIDH
		msg |= (MsgBuf[2] >> 5);			// SIDL
		// ?????????
//		sprintf(StrBuf, "M=%04X", msg);		// ?????(SID)??
//		LCDString(StrBuf);

		switch(msg) {
			case N2_LCD_NUM:					// ?????
				count = ((WORD)MsgBuf[6] << 8) | MsgBuf[7];	// ?????
				LCDPrintAt(0, 0);
				sprintf(StrBuf, "%04d", count;
				LCDString(StrBuf);				// LCD?10???
				break;
		}
	}
}


//
// Occurrence - Btn1Press
//
void Btn1Press()
{
}
//
// Occurrence - Btn2Press
//
void Btn2Press()
{
}
//
// Occurrence - Btn3Press
//
void Btn3Press()
{
}
